unit U_Turtle;

interface
uses ExtCtrls, graphics, windows, forms;
type
  Tturtle_im = class(Timage)              {Tturtle_im erbt alles von Timage}
          procedure vw(s:integer);        {Tturtle_im erhlt zustzliche Methoden}
          procedure dl(winkel:extended);
          procedure show_igel;
          procedure hide_igel;
          procedure stift_auf;
          procedure stift_ab;
          procedure text_aus(s:string; g:integer);
          procedure init;
     public
          igel_v:integer;                 {zustzliche verffentlichte Eigenschaft,
                                           Verzgerung der Turtle}
     private
          stift_unten,igel_sichtbar:boolean; {weitere Eigenschaften, die nicht verffentlicht werden}
          x,y, alpha :extended;
          procedure igel_z;               {weitere Methoden, die nur intern verfgbar sind}
          procedure h_vw(s:integer;schreiben:boolean);
          procedure h_dl(winkel:extended);
  end;


implementation

    procedure Tturtle_im.h_vw(s:integer; schreiben:boolean);
    begin
      with canvas do begin
        x:=x-s*sin(alpha); {genaue Buchhaltung erforderlich!}
        y:=y-s*cos(alpha);
        if schreiben then lineto(Round(x),Round(y))
                     else moveto(Round(x),Round(y))
        end;
    end;

    procedure Tturtle_im.vw(s:integer);
    begin
       if igel_sichtbar then igel_z;
       h_vw(s,stift_unten);
       if igel_sichtbar then igel_z;
       if igel_v >0 then begin
          sleep(igel_v);
          application.processmessages;
          end
    end;

    procedure Tturtle_im.h_dl(winkel:extended);
    begin
       while alpha>2*pi do alpha:=alpha-2*pi;
       alpha:=alpha+winkel/180*pi;
    end;

    procedure Tturtle_im.dl(winkel:extended);
    begin
       if igel_sichtbar then igel_z;
       h_dl(winkel);
       if igel_sichtbar then igel_z;
    end;

    procedure Tturtle_im.igel_z;
    var xx,yy,aa:real;
    begin
   // xx:=x;yy:=y;aa:=alpha; {alte Werte retten}
      with canvas do begin
        pen.Mode:=pmNotXor;
        h_dl(90); h_vw(6,true);h_dl(240); h_vw(12,true);h_dl(240);h_vw(12,true);
        h_dl(240);h_vw(6,true);h_dl(270);
        pen.Mode:=pmCopy;
        end;
   //  x:=xx; y:=yy; alpha:=aa {alte Werte einsetzen}
    end;

    procedure Tturtle_im.show_igel;
    begin
      if not igel_sichtbar then igel_z;
         igel_sichtbar:=true;
    end;

    procedure Tturtle_im.hide_igel;
    begin
       if igel_sichtbar then igel_z;
          igel_sichtbar:=false;
    end;

    procedure Tturtle_im.stift_auf;
    begin
//       if igel_sichtbar then igel_z;
       stift_unten:=false;
    end;

    procedure Tturtle_im.stift_ab;
    begin
       stift_unten:=true;
//       if igel_sichtbar then igel_z;
    end;

    procedure Tturtle_im.init;
    begin
      alpha:=0; x:=width  div 2; y:=height div 2;
      canvas.rectangle(0,0,width,height); //Lschen
      canvas.moveto(Round(x), Round(y));
      stift_unten:=true;
      igel_sichtbar:=true; igel_z;
      igel_v:=0;
      canvas.pen.mode:=PmCopy;
    end;


    procedure Tturtle_im.text_aus(s:string; g:integer);
    var j:integer;
   {$i I_Buchstabendefinition.pas}
   {Dort sind einzelne Buchstaben definiert.}
    begin {text_aus}
       for j:=1 to length(s) do
          buchstabe(s[j],g);
    end;
 end.
